#include<bits/stdc++.h>
using namespace std;
void get_int(int &res)
{
    if(scanf("%d",&res)!=1)
        exit(1);
}
void get_long(long long &res)
{
    if(scanf("%lld",&res)!=1)
        exit(1);
}
void get_string(char* res)
{
    if(scanf("%s",res)!=1)
        exit(1);
}
bool is_whitespace(char c)
{
    return c == ' ' || c == '\t' || c == '\n' || c == '\r';
}
void read_until_eof()
{
    char ch = getchar();
    while (ch != EOF && is_whitespace(ch))
    {
        ch = getchar();
    }
    if (ch != EOF)
    {
        exit(1);
    }
}
int a[100005];
int main()
{
    for(int testcase=1; testcase<=10; testcase++)
    {
        char input[20];
        sprintf(input,"%d.in",testcase);
        freopen(input,"r",stdin);
        int T,n,m,i,x,y;
        long long k;
        get_int(T);
        if(T<1||T>5)
            exit(1);
        while(T--)
        {
            get_int(n);
            if(n<1||n>100000)
                exit(1);
            get_int(m);
            if(m<1||m>100000)
                exit(1);
            for(i=1; i<=n; i++)
            {
                get_int(a[i]);
                if(a[i]<1||a[i]>1000000000)
                    exit(1);
            }
            for(i=1;i<=m;i++)
            {
                get_int(x);
                if(x<1||x>n)
                    exit(1);
                get_int(y);
                if(y<1||y>n)
                    exit(1);
            }
        }
        read_until_eof();
    }
    return 0;
}
